;@echo off
;color e0
;goto make

.386
.model flat, stdcall
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\ntoskrnl.inc
include \masm32\macros\Strings.mac
include \masm32\include\w2k\ntstatus.inc
include \masm32\include\w2k\ntddk.inc
include \masm32\include\w2k\w2kundoc.inc

IOCTL_SEND_COMMAND	equ CTL_CODE(FILE_DEVICE_UNKNOWN, 800h, METHOD_BUFFERED, FILE_READ_ACCESS + FILE_WRITE_ACCESS)
PDRIVER_OBJECT typedef PTR DRIVER_OBJECT
PUNICODE_STRING typedef PTR UNICODE_STRING

.const
CCOUNTED_UNICODE_STRING	"\\Device\\devnative", cusDeviceName, 4
CCOUNTED_UNICODE_STRING	"\\??\\slnative", cusSymbolicLinkName, 4

.code

DispatchCreateClose proc pDeviceObject:PDEVICE_OBJECT, pIrp:PIRP
	mov eax, pIrp
	assume eax:ptr _IRP
	mov [eax].IoStatus.Status, STATUS_SUCCESS
	and [eax].IoStatus.Information, 0
	assume eax:nothing
	fastcall @IofCompleteRequest, pIrp, IO_NO_INCREMENT
	mov eax, STATUS_SUCCESS
	ret
DispatchCreateClose endp

DispatchControl proc uses esi edi ebx pDeviceObject:PDEVICE_OBJECT, pIrp:PIRP
local status:NTSTATUS
local dwBytesReturned:DWORD
local DelayTime:LARGE_INTEGER
	mov status, STATUS_INVALID_DEVICE_REQUEST
	and dwBytesReturned, 0
	mov esi, pIrp
	assume esi:ptr _IRP
	IoGetCurrentIrpStackLocation esi
	mov edi, eax
	assume edi:ptr IO_STACK_LOCATION
	.if [edi].Parameters.DeviceIoControl.IoControlCode == IOCTL_SEND_COMMAND
		mov status, STATUS_SUCCESS
		mov edi, [esi].AssociatedIrp.SystemBuffer
		assume edi:ptr DWORD
		.if dword ptr[edi]==1
			invoke	InbvResetDisplay
			invoke InbvSolidColorFill, 0, 0, 639, 479, [edi][1*(sizeof DWORD)]
			invoke InbvSetTextColor, [edi][2*(sizeof DWORD)]
		.elseif dword ptr[edi]==2
			invoke InbvSolidColorFill, 0, 0, 639, 479, [edi][1*(sizeof DWORD)]
			invoke InbvSetTextColor, [edi][2*(sizeof DWORD)]
		.elseif dword ptr[edi]==3
			cli
			mov	al, 182
			out	43h, al
			mov	ax, 4560
			out	42h, al
			mov	al, ah
			out	42h, al
			in	al, 61h
			or	al, 00000011b
			out	61h, al
			sti
			mov DelayTime.HighPart, -1
			mov DelayTime.LowPart, -5000000
			invoke KeDelayExecutionThread, KernelMode, FALSE, addr DelayTime
			cli
			in	al, 61h
			and	al, 11111100b
			out	61h, al
			sti
		.endif
	.else
		mov status, STATUS_INVALID_DEVICE_REQUEST
	.endif
	assume edi:nothing
	push status
	pop [esi].IoStatus.Status
	push dwBytesReturned
	pop [esi].IoStatus.Information
	assume esi:nothing
	fastcall @IofCompleteRequest, pIrp, IO_NO_INCREMENT
	mov eax, status
	ret
DispatchControl endp

DriverUnload proc pDriverObject:PDRIVER_OBJECT
	invoke IoDeleteSymbolicLink, addr cusSymbolicLinkName
	mov eax, pDriverObject
	invoke IoDeleteDevice, (DRIVER_OBJECT PTR [eax]).DeviceObject
	ret
DriverUnload endp

.code INIT

DriverEntry proc pDriverObject:PDRIVER_OBJECT, pusRegistryPath:PUNICODE_STRING
local status:NTSTATUS
local pDeviceObject:PVOID
	mov status, STATUS_DEVICE_CONFIGURATION_ERROR
	invoke IoCreateDevice, pDriverObject, 0, addr cusDeviceName, FILE_DEVICE_UNKNOWN, \
											 0, FALSE, addr pDeviceObject
	.if eax == STATUS_SUCCESS
		invoke IoCreateSymbolicLink, addr cusSymbolicLinkName, addr cusDeviceName
		.if eax == STATUS_SUCCESS
			mov eax, pDriverObject
			assume eax:PTR DRIVER_OBJECT
			mov [eax].MajorFunction[IRP_MJ_CREATE*(sizeof PVOID)], offset DispatchCreateClose
			mov [eax].MajorFunction[IRP_MJ_CLOSE*(sizeof PVOID)], offset DispatchCreateClose
			mov [eax].MajorFunction[IRP_MJ_DEVICE_CONTROL*(sizeof PVOID)], offset DispatchControl
			mov [eax].DriverUnload, offset DriverUnload
			assume eax:nothing
			mov status, STATUS_SUCCESS
		.else
			invoke IoDeleteDevice, pDeviceObject
		.endif
	.endif
	mov eax, status
	ret
DriverEntry endp
end DriverEntry

:make
\masm32\bin\ml /nologo /c /coff %~nx0
\masm32\bin\link /nologo /driver /base:0x10000 /align:32 /out:%~n0.sys /subsystem:native /ignore:4078 %~n0.obj
del %~n0.obj
echo.
pause